<?php
namespace Zeedhi\PaymentPlatform\NonInstantBuy;

use Zeedhi\PaymentPlatform\Transaction;
use Zeedhi\PaymentPlatform\CreditCard;
use  Zeedhi\PaymentPlatform\Customer;

class NonInstantBuyTransactionTest extends \PHPUnit_Framework_TestCase {
    
    /** @var NonInstantBuyTransaction */
    protected $nonInstantBuyTransaction;
    /** @var String */
    protected $value = "100.00"; 
    /** @var String */
    protected $transactionId = "00001"; 
    /** @var CreditCard */
    protected $creditCard; 
    /** @var Customer */
    protected $customer;
    /** @var Int */
    protected $nrInstallment = 1;
    
    public function setUp(){
        $this->creditCard = $this->getMockBuilder(creditCard::class)
                            ->setMethods(array())
                            ->disableOriginalConstructor()
                            ->getMock();
                            
        $this->customer =  $this->getMockBuilder(Customer::class)
                                    ->setMethods(array())
                                    ->disableOriginalConstructor()
                                    ->getMock();
        $this->nonInstantBuyTransaction = new NonInstantBuyTransaction($this->value, $this->transactionId, $this->creditCard, $this->customer, $this->nrInstallment);
    }
    
    public function testGetCreditCard() {
        $this->assertEquals($this->creditCard, $this->nonInstantBuyTransaction->getCreditCard());
    }
    
    public function testGetValue() {
        $this->assertEquals($this->value, $this->nonInstantBuyTransaction->getValue());
    }
    
    public function testGetTransactionId() {
        $this->assertEquals($this->transactionId, $this->nonInstantBuyTransaction->getTransactionId());
    }

    public function testGetCustomer() {
        $this->assertEquals($this->customer, $this->nonInstantBuyTransaction->getCustomer());
    }
    
    public function testGetNrInstallment() {
        $this->assertEquals($this->nrInstallment, $this->nonInstantBuyTransaction->getNrInstallment());
    }
}
