function AutoRechargeController(templateManager, AutoRechargeService, LoginRepository, ScreenService, CreditCards){

    this.getAutoRechargeDetails = function(widget){
        LoginRepository.findOne().then(function (consumerData){
            CreditCards.clearAll().then(function (){
                AutoRechargeService.getAutoRechargeDetails(consumerData['CDCLIENTE'], consumerData['CDCONSUMIDOR'], consumerData['CDFILIAL']).then(function (rechargeDetails){
                    widget.dataSource.data = rechargeDetails['AutoRechargeRepository'];
                    templateManager.updateTemplate();
                });
            });
        });
    };

    this.confirmAutoRecharge = function(row, gridWidget){
        if (row.VRMINVAL == null || row.VRMINVAL.length == 0) row.VRMINVAL = "0";
        if (row.VRCHARGE == null || row.VRCHARGE.length == 0) row.VRCHARGE = "0";

        var VRMINSALDORRECAR = parseFloat(row.VRMINVAL.replace(',', '.'));
        var VRRECARGARAUT = parseFloat(row.VRCHARGE.replace(',', '.'));

        if (isNaN(VRMINSALDORRECAR) || VRMINSALDORRECAR < 0){
            row.$error['VRMINVAL'] = [{"message" : "valor inválido", "class": "field-require"}];
        }
        else if (isNaN(VRRECARGARAUT) || VRRECARGARAUT < 0){
            row.$error['VRCHARGE'] = [{"message" : "valor inválido", "class": "field-require"}];
        }
        else if (VRRECARGARAUT <= VRMINSALDORRECAR && (VRRECARGARAUT != 0 && VRMINSALDORRECAR != 0)){
            ScreenService.showMessage("O valor da recarga tem que ser maior que o valor mínimo.");
        }
        else if (row.changed === undefined || row.changed == false){
            ScreenService.closePopup();
        }
        else {
            var confirmText = "Confirma a realização de recargas automáticas no valor de " + VRRECARGARAUT.toMoney() + " quando o saldo for inferior à " + VRMINSALDORRECAR.toMoney() + "?";
            ScreenService.confirmMessage(confirmText, "question").then(
                function (){
                    LoginRepository.findOne().then(function (consumerData){
                        AutoRechargeService.confirmAutoRecharge(consumerData.CDCLIENTE, consumerData.CDCONSUMIDOR, row.CDFAMILISALD, VRMINSALDORRECAR, VRRECARGARAUT, consumerData.CDFILIAL).then(function (rechargeDetails){
                            ScreenService.successNotification("Recarga automática configurada.");
                            ScreenService.closePopup();
                            gridWidget.dataSource.data = rechargeDetails;
                            templateManager.updateTemplate();
                        });
                    });
                },
                function (){
                    // Do nothing.
                }
            );
        }
    };

    this.clearAutoRecharge = function(row, gridWidget){
        ScreenService.confirmMessage("Deseja excluir a recarga automática selecionada?", "question").then(
            function (){
                LoginRepository.findOne().then(function (consumerData){
                    AutoRechargeService.confirmAutoRecharge(consumerData.CDCLIENTE, consumerData.CDCONSUMIDOR, row.CDFAMILISALD, 0, 0, consumerData.CDFILIAL).then(function (rechargeDetails){
                        ScreenService.successNotification("Recarga automática excluida.");
                        ScreenService.closePopup();
                        gridWidget.dataSource.data = rechargeDetails;
                        templateManager.updateTemplate();
                    });
                });
            },
            function (){
                // Do nothing.
            }
        );
    };

    this.prepareAutoRechargePopup = function(row, popup){
        CreditCards.findAll().then(function (cards){
            if (cards.length > 0){
                popup.label = row.NMFAMILISALD;

                var newRow = {
                    "VRMINVAL": row.VRMINSALDORRECAR,
                    "VRCHARGE": row.VRRECARGARAUT,
                    "CDFAMILISALD": row.CDFAMILISALD
                };

                if (parseFloat(row.VRMINSALDORRECAR) == 0) newRow.VRMINVAL = null;
                if (parseFloat(row.VRRECARGARAUT) == 0) newRow.VRCHARGE = null;
                popup.setCurrentRow(newRow);
                ScreenService.openPopup(popup);
            }
            else {
                ScreenService.showMessage("Favor cadastrar um cartão de crédito antes de configurar uma recarga automática.");
            }
        });
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('AutoRechargeController', AutoRechargeController);
});
